using System;
using System.IO;
using System.Text;
using System.Collections;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;

namespace netGuest {
	public class c_Guest : Page {
		protected Repeater MyDataList;
		protected Label lblErrMsg;

		protected void Page_Init(object sender,EventArgs e) {
			InitializeComponent();
		}
		
		private void InitializeComponent() {
			this.Load += new System.EventHandler(this.Page_Load);
		}
		
		public void Page_Load(Object sender, EventArgs e) {	
			string datafile = "guestbook.xml" ;
	
			try
        		{
	            	XmlDataDocument xmlDataDoc = new XmlDataDocument();

								FileStream fin ;
								fin = new FileStream(Server.MapPath(datafile),FileMode.Open, FileAccess.Read,FileShare.ReadWrite) ; 

	            	xmlDataDoc.DataSet.ReadXml(new StreamReader(fin));

								fin.Close();

				try {
					MyDataList.DataSource = xmlDataDoc.DataSet.Tables[0].DefaultView;
       	 			MyDataList.DataBind();
					}
					
				catch (System.IndexOutOfRangeException err) {
						lblErrMsg.Text = "Ͽ Էµ  ϴ.";
					}

						xmlDataDoc = null;
     		}

				catch (Exception edd) {
					lblErrMsg.Text="XML    ϴ. <br>Error :"+edd.ToString() ;
     		}
		}
	}

	public class c_Write : Page {
		protected Label lblErrMsg;
		protected TextBox txtName;
		protected TextBox txtEmail;
		protected TextBox txtHeading;
		protected TextBox txtComment;
		protected Button btnWrite;

		protected void Page_Init(object sender,EventArgs e)
		{
			InitializeComponent();
		}

		private void InitializeComponent()
		{
			btnWrite.Click += new System.EventHandler(this.btnWrite_Click);
		}

		public void Page_Load(Object sender, EventArgs e)
		{	
		}

		public void btnWrite_Click(Object sender, EventArgs e)
		{
			string datafile = "guestbook.xml" ;

			try {
				lblErrMsg.Text="" ;

				XmlDocument xmlDoc = new XmlDocument() ;
					
				FileStream fin ;
				fin = new FileStream(Server.MapPath(datafile), FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
				
				xmlDoc.Load(new StreamReader(fin)) ;
				fin.Close();
				
				XmlNode root = xmlDoc.DocumentElement;
 
				XmlNode newElem = xmlDoc.CreateNode("element","Guest","");
    				root.AppendChild(newElem);
						
				XmlElement Fist_Elem = xmlDoc.CreateElement("Name");
				XmlElement second_Elem = xmlDoc.CreateElement("Email");
   			XmlElement third_Elem = xmlDoc.CreateElement("Heading");
				XmlElement Fourth_Elem = xmlDoc.CreateElement("Comments");
				XmlElement Fifth_Elem = xmlDoc.CreateElement("DateTime");
												
				Fist_Elem.InnerText=txtName.Text;
				second_Elem.InnerText=txtEmail.Text;
				third_Elem.InnerText=txtHeading.Text;
				Fourth_Elem.InnerText=txtComment.Text;
				DateTime now = DateTime.Now ;
				Fifth_Elem.InnerText=now.ToString();
			
 				newElem.InsertAfter(Fist_Elem, newElem.FirstChild);
				newElem.InsertAfter(second_Elem, newElem.FirstChild);
				newElem.InsertAfter(third_Elem, newElem.FirstChild);
				newElem.InsertAfter(Fourth_Elem, newElem.FirstChild);
				newElem.InsertAfter(Fifth_Elem, newElem.FirstChild);		

				FileStream fout ;
				fout = new FileStream(Server.MapPath(datafile), FileMode.Open, FileAccess.Write, FileShare.ReadWrite) ;
				
				xmlDoc.Save(new StreamWriter(fout)) ;
				xmlDoc=null ;

				fout.Close();

				Response.Redirect("guestbook.aspx");
				}
			
			catch (Exception edd) {
					lblErrMsg.Text=edd.ToString() + "   ۼ  ϴ.";
   		}
		}
	}
}