if exists (select * from sysobjects where id = object_id(N'[dbo].[tblAttachFile]')
 and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblAttachFile]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[tblBoard]')
 and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblBoard]
GO

CREATE TABLE [dbo].[tblAttachFile] (
	[fAttachKey] [int] IDENTITY (1, 1) NOT NULL ,
	[fBoardKey] [int] NULL ,
	[fFilename] [varchar] (50) NULL ,
	[fFilesize] [int] NULL ,
	[fFilepath] [varchar] (100) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblBoard] (
	[fBoardKey] [int] IDENTITY (1, 1) NOT NULL ,
	[fSubject] [varchar] (50) NULL ,
	[fWriter] [varchar] (50) NULL ,
	[fEmail] [varchar] (50) NULL ,
	[fContent] [text] NULL ,
	[fDate] [datetime] NULL ,
	[fVisited] [int] NULL ,
	[fGroup] [int] NULL ,
	[fAnsStep] [int] NULL ,
	[fPassword] [varchar] (50) NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[tblAttachFile] WITH NOCHECK ADD 
	CONSTRAINT [PK_tblAttachFile] PRIMARY KEY  NONCLUSTERED 
	(
		[fAttachKey]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tblBoard] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblBoard_fVisited] DEFAULT (0) FOR [fVisited],
	CONSTRAINT [DF_tblBoard_fGroup] DEFAULT (0) FOR [fGroup],
	CONSTRAINT [DF_tblBoard_fStep] DEFAULT (0) FOR [fAnsStep],
	CONSTRAINT [PK_tblBoard] PRIMARY KEY  NONCLUSTERED 
	(
		[fBoardKey]
	)  ON [PRIMARY] 
GO