namespace PDS
{
	using System;
	using System.IO;
	using System.Text;
	using System.Collections;
	using System.Data;
	using System.Data.SqlClient;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Web.Services;
	using System.Globalization; 

	public class cFileData
	{
		private string strDsn = "server=localhost;uid=sa;pwd=;database=pds";
		private SqlConnection m_Con = null;

		private string uploadPath = "c:\\";

		public cFileData(){}

		~cFileData(){}

		public SqlConnection getCon()
		{
			if (m_Con == null)
			{
				m_Con = new SqlConnection(strDsn);
			}
			return (m_Con);
		}

		public void DBOpen()
		{
			m_Con.Open();
		}

		public void DBClose()
		{
			m_Con.Close();
		}

		public string FilePath
		{
			get
			{
				return (uploadPath);
			}
			set
			{
				uploadPath = value;
			}
		}

		public string cv2Db(string value)
		{
			string strReturn = "";
			StringBuilder sb;
			if((value != null) && (value != String.Empty))
			{
				sb = new StringBuilder(value);
				strReturn = sb.Replace("'","''").ToString();
			}
			return (strReturn);
		}

		public string cv2Html(string value)
		{
			string strReturn = "";
			StringBuilder sb;
			if((value != null) && (value != String.Empty))
			{
				sb = new StringBuilder(value);
				strReturn = sb.Replace("\x0A","<br>").ToString();
			}
			return (strReturn);
		}

		public DataTable getBoardInfo(string sql)
		{
			DataSet ds = new DataSet();
			SqlDataAdapter cmd = new SqlDataAdapter(sql,getCon());
			cmd.Fill(ds,"tblBoard");
			return ds.Tables["tblBoard"];
		}

		public void executeQuery(string sql)
		{
			SqlCommand cmd = new SqlCommand(sql,getCon());
			DBOpen();
			cmd.ExecuteNonQuery();
			DBClose();
		}

		public int saveBoard(string title,string name,string email, string pass,string content)
		{
			int fBoardKey = 0;

			string sql = "insert into tblBoard(fSubject,fWriter,fEmail,fPassword,fContent,fDate)";
			sql += " values(@fSubject,@fWriter,@fEmail,@fPassword,@fContent,@fDate)";
			SqlCommand cmd = new SqlCommand(sql,getCon());

			cmd.Parameters.Add(new SqlParameter("@fSubject",SqlDbType.VarChar,50));
			cmd.Parameters["@fSubject"].Value = title;

			cmd.Parameters.Add(new SqlParameter("@fWriter",SqlDbType.VarChar,50));
			cmd.Parameters["@fWriter"].Value = name;

			cmd.Parameters.Add(new SqlParameter("@fEmail",SqlDbType.VarChar,50));
			cmd.Parameters["@fEmail"].Value = email;

			cmd.Parameters.Add(new SqlParameter("@fPassword",SqlDbType.VarChar,50));
			cmd.Parameters["@fPassword"].Value = pass;

			cmd.Parameters.Add(new SqlParameter("@fContent",SqlDbType.Text));
			cmd.Parameters["@fContent"].Value = content;

			cmd.Parameters.Add(new SqlParameter("@fDate",SqlDbType.DateTime,10));
			DateTime dtNow = DateTime.Today;
			cmd.Parameters["@fDate"].Value = dtNow.ToString();

			DBOpen();
			cmd.ExecuteNonQuery();
			
			sql = "select fBoardKey from tblBoard where fGroup=0";
			cmd.CommandText = sql;
			SqlDataReader rd;
			rd = cmd.ExecuteReader();

			while(rd.Read())
			{
				fBoardKey = rd.GetInt32(0);
			}
			rd.Close();

			sql = "update tblBoard set fGroup=fBoardKey where fGroup=0";
			cmd.CommandText = sql;
			cmd.ExecuteNonQuery();
			DBClose();
			return fBoardKey;
		}

		public int saveBoard(string title,string name,string email, string pass,string content,int group,int step)
		{
			int fBoardKey = 0;

			string sql = "insert into tblBoard(fSubject,fWriter,fEmail,fPassword,fContent,fDate,fAnsStep)";
			sql += "values(@fSubject,@fWriter,@fEmail,@fPassword,@fContent,@fDate,@fAnsStep)";
			SqlCommand cmd = new SqlCommand(sql,getCon());

			cmd.Parameters.Add(new SqlParameter("@fSubject",SqlDbType.VarChar,50));
			cmd.Parameters["@fSubject"].Value = title;

			cmd.Parameters.Add(new SqlParameter("@fWriter",SqlDbType.VarChar,50));
			cmd.Parameters["@fWriter"].Value = name;

			cmd.Parameters.Add(new SqlParameter("@fEmail",SqlDbType.VarChar,50));
			cmd.Parameters["@fEmail"].Value = email;

			cmd.Parameters.Add(new SqlParameter("@fPassword",SqlDbType.VarChar,50));
			cmd.Parameters["@fPassword"].Value = pass;

			cmd.Parameters.Add(new SqlParameter("@fContent",SqlDbType.Text));
			cmd.Parameters["@fContent"].Value = content;

			cmd.Parameters.Add(new SqlParameter("@fDate",SqlDbType.DateTime,10));
			DateTime dtNow = DateTime.Today;
			cmd.Parameters["@fDate"].Value = dtNow.ToString();

			cmd.Parameters.Add(new SqlParameter("@fAnsStep",SqlDbType.Int,4));
			cmd.Parameters["@fAnsStep"].Value = step;

			DBOpen();
			cmd.ExecuteNonQuery();

			sql = "select fBoardKey from tblBoard where fGroup=0";
			cmd.CommandText = sql;
			SqlDataReader rd;
			rd = cmd.ExecuteReader();

			while(rd.Read())
			{
				fBoardKey = rd.GetInt32(0);
			}
			rd.Close();

			sql = "update tblBoard set fGroup=" + group.ToString() + " where fGroup=0";
			cmd.CommandText = sql;
			cmd.ExecuteNonQuery();
			DBClose();
			return fBoardKey;
		}

		public void updateBoard(string fkey,string title,string name, string email,string content)
		{
			string sql = "update tblBoard set fSubject=@fSubject,";
			sql += "fWriter=@fWriter,fEmail=@fEmail,fContent=@fContent,fDate=@fDate";
			sql += " where fBoardKey=" + fkey;
			SqlCommand cmd = new SqlCommand(sql,getCon());

			cmd.Parameters.Add(new SqlParameter("@fSubject",SqlDbType.VarChar,50));
			cmd.Parameters["@fSubject"].Value = title;

			cmd.Parameters.Add(new SqlParameter("@fWriter",SqlDbType.VarChar,50));
			cmd.Parameters["@fWriter"].Value = name;

			cmd.Parameters.Add(new SqlParameter("@fEmail",SqlDbType.VarChar,50));
			cmd.Parameters["@fEmail"].Value = email;

			cmd.Parameters.Add(new SqlParameter("@fContent",SqlDbType.Text));
			cmd.Parameters["@fContent"].Value = content;

			cmd.Parameters.Add(new SqlParameter("@fDate",SqlDbType.DateTime,10));
			DateTime dtNow = DateTime.Today;
			cmd.Parameters["@fDate"].Value = dtNow.ToString();

			DBOpen();
			cmd.ExecuteNonQuery();
			DBClose();
		}

		private string saveFile(int fBoardKey,string fname,int fsize)
		{
			int fAttachKey = 0;
			string filepath = null;
			string sql = "insert into tblAttachFile(fBoardKey,fFileName,fFileSize)";
			sql += " values(@fBoardKey,@fFileName,@fFileSize)";

			SqlCommand cmd = new SqlCommand(sql,getCon());

			cmd.Parameters.Add(new SqlParameter("@fBoardKey",SqlDbType.Int,4));
			cmd.Parameters["@fBoardKey"].Value = fBoardKey;

			cmd.Parameters.Add(new SqlParameter("@fFileName",SqlDbType.VarChar,50));
			cmd.Parameters["@fFileName"].Value = fname;

			cmd.Parameters.Add(new SqlParameter("@fFileSize",SqlDbType.Int,4));
			cmd.Parameters["@fFileSize"].Value = fsize;

			DBOpen();
			cmd.ExecuteNonQuery();
			
			sql = "select fAttachKey from tblAttachFile where fFilePath Is Null";
			cmd.CommandText = sql;
			SqlDataReader rd;
			rd = cmd.ExecuteReader();
			while(rd.Read())
			{
				fAttachKey = rd.GetInt32(0);
			}
			rd.Close();

			filepath = makeFilePath(fAttachKey,fname);
			sql = "update tblAttachFile set fFilePath='" + filepath + "' where fFilePath Is Null";
			cmd.CommandText = sql;
			cmd.ExecuteNonQuery();
			DBClose();
			return (filepath);

		}

		private string makeFilePath(int key,string fname)
		{
			string ext = fname.Substring(fname.LastIndexOf(".")+1);
			string filename = key.ToString() + "." +ext;
			string filepath = uploadPath + filename;

			return filepath;
		}

		public void deleteFile(int fBoardKey)
		{
			DataTable dt = getFileInfo(fBoardKey);

			foreach(DataRow dr in dt.Rows)
			{
				deleteFile(dr["fFilePath"].ToString());
			}

			string sql = "delete from tblAttachFile where fBoardKey=" + fBoardKey;
			executeQuery(sql);
		}
	
		private void deleteFile(string filepath)
		{
			File.Delete(filepath);
		}

		public void uploadFile(int fBoardKey,HttpPostedFile file)
		{
			string filename = file.FileName.Substring(file.FileName.LastIndexOf("\\")+1);
			int filesize = file.ContentLength;

			string filepath = saveFile(fBoardKey,filename,filesize);
			file.SaveAs(filepath);
		}

		public DataTable getFileInfo(int fBoardKey)
		{
			DataSet ds = new DataSet();
			string sql = "select * from tblAttachFile where fBoardKey = " + fBoardKey;
			SqlDataAdapter cmd = new SqlDataAdapter(sql,getCon());
			cmd.Fill(ds,"file");
			return	ds.Tables["file"];
		}
	}

	public class cList : Page
	{
		protected TextBox m_txtSearchText;
		protected Button btnSearch;
		protected ListBox Search;
		protected HtmlInputHidden lblSql;
		protected DataGrid m_DbGrid;
		private string m_sql;

		protected void Page_Init(object sender,EventArgs e)
		{
			InitializeComponent();
		}

		private void InitializeComponent()
		{
			btnSearch.Click += new System.EventHandler(this.btnSearch_Click);

			Search.Rows = 1;
			m_DbGrid.AutoGenerateColumns=false;
			m_DbGrid.AllowPaging = true;
			m_DbGrid.PageSize = 10;
		}

		public void Page_Load(Object sender,EventArgs e)
		{
			if(!IsPostBack)
			{
				cFileData db = new cFileData();

				m_sql = Request["sql"];
				lblSql.Value = m_sql;

				if((m_sql == "") || (m_sql == String.Empty) || (m_sql == null))
				{
					m_sql = makeQuery();
				}

				DataTable dt = db.getBoardInfo(m_sql);
				Bind(dt);
			}
		}

		public void btnSearch_Click(object sender,EventArgs e)
		{
			cFileData db = new cFileData();

			DataTable dt = db.getBoardInfo(makeQuery());
			Bind(dt);
		}

		public string makeQuery()
		{
			string sql;
			int mode = 0;

			for (int i=0;i<Search.Items.Count;i++)
			{
				if(Search.Items[i].Selected == true)
				{
					mode =int.Parse(Search.Items[i].Value.ToString());
				}
			}

			cFileData db = new cFileData();
			string content = db.cv2Db(m_txtSearchText.Text);

			switch (mode)
			{
				case 1:
		sql = "select * from tblBoard where fSubject Like '%" + content + "%'";
		sql += " order by fGroup DESC,fAnsStep ASC";
				break;
		
		case 2:
		sql = "select * from tblBoard where fContent Like '%" + content + "%'";
		sql += " order by fGroup DESC,fAnsStep ASC";
				break;

				case 3:
		sql = "select * from tblBoard where (fSubject Like '%" + content + "%')";
		sql += " or (fContent like '%" + content + "%')";
		sql += " order by fGroup DESC,fAnsStep ASC";
				break;

				default:
		sql = "select * from tblBoard order by fGroup DESC,fAnsStep ASC";
				break;
			}
			
			lblSql.Value = sql;
			return sql;
		}
		
		public void Bind(DataTable dt)
		{
			DataView dv = new DataView(dt);
			m_DbGrid.DataSource = dv;
			m_DbGrid.DataBind();
		}

		public string setReplyPos(Object obj)
		{
			int m_Step;
			m_Step = (int)obj;
			String dspBlank = "";

			if(m_Step >0)
			{
				while (m_Step > 0)
				{
					dspBlank += "&nbsp;&nbsp";
					m_Step--;
				}
				dspBlank += "[Re]";
			}
			return dspBlank;
		}

		public string showNumber(Object step , Object number)
		{
			string strReturn;
			int m_step = (int)step;

			if(m_step != 0)
			{
				strReturn = "";
			}

			else
			{
				strReturn = number.ToString();
			}
			return (strReturn);
		}

		public string showEmail(Object email)
		{
			string rtn = String.Empty;
			if(email !=null)
			{
				if(email.ToString() != String.Empty && email.ToString() != "")
				rtn = "mailto:" + email.ToString();
			}
			return rtn;
		}

	public void Page_Move(Object sender,DataGridPageChangedEventArgs e)
		{
			m_DbGrid.CurrentPageIndex = e.NewPageIndex;
			string sql = lblSql.Value;
			cFileData db = new cFileData();
			Bind(db.getBoardInfo(sql));
		}

		public string showSubject(string subject)
		{
			string strReturn = subject ;
			System.Text.StringBuilder sb = new System.Text.StringBuilder("");
			int displayLength =10;

			if((subject.Length > displayLength) &&(subject != String.Empty) && (subject != null))
			{
				sb.Append(subject,1,displayLength);
				sb.Append("...");
				strReturn = sb.ToString();
			}
			return (strReturn);
		}
	}

	public class cWrite : Page
	{
		protected TextBox txtSubject;
		protected TextBox txtWriter;
		protected TextBox txtEmail;
		protected TextBox txtPassword;
		protected TextBox txtComment;
		protected HtmlInputFile file1;
		protected HtmlInputFile file2;

		protected Button btnSave;
		protected Button btnCancel;
		
		protected void Page_Init(object sender,EventArgs e)
		{
			InitializeComponent();
		}

		private void InitializeComponent()
		{
			btnSave.Click += new System.EventHandler(this.Save_Click);
			btnCancel.Click += new System.EventHandler(this.List_Click);
		}
		
		public void Page_Load(Object sender,EventArgs e)
		{
			if(!IsPostBack)
			{
			}
		}
		
		public void List_Click(Object sender,EventArgs e)
		{
			Response.Redirect("list.aspx");
		}
		
		public void Save_Click(Object sender,EventArgs e)
		{
			cFileData db = new cFileData();
			int fBoardKey = db.saveBoard(txtSubject.Text,txtEmail.Text,txtWriter.Text, txtPassword.Text,txtComment.Text);

			if(fBoardKey >0)
			{
				if(file1.PostedFile!=null && file1.PostedFile.FileName != "" )
				{
					db.uploadFile(fBoardKey,file1.PostedFile);

				}

				if(file2.PostedFile!=null && file2.PostedFile.FileName != "" )
				{
					db.uploadFile(fBoardKey,file2.PostedFile);
				}

				Response.Redirect("list.aspx");
			}
		}

	}

	public class cView : Page
	{
		protected HtmlInputHidden lblSql;
		protected HtmlInputHidden lblKey;
		protected DataGrid m_DbGrid;
		protected HyperLink lnkBack;
		protected HyperLink lnkModify;
		protected HyperLink lnkReply;

		private string m_sql="";

		protected void Page_Init(object sender,EventArgs e)
		{
			InitializeComponent();
		}

		private void InitializeComponent()
		{
			m_DbGrid.AutoGenerateColumns=false;
			m_DbGrid.AllowPaging = true;
			m_DbGrid.PageSize = 1;
		}

		public void Page_Load(Object sender,EventArgs e)
		{
			if(!IsPostBack)
			{
				m_sql = Request["sql"];
				lblSql.Value = m_sql;

				int selected = int.Parse(Request["num"].ToString());
				cFileData db = new cFileData();

				DataTable dt = db.getBoardInfo(m_sql);

				for(int index=0;index < dt.Rows.Count;index++)
				{
					if(selected ==int.Parse(dt.Rows[index]["fBoardKey"].ToString()))
					{
						selected = index;
						break;
					}
				}

				m_DbGrid.CurrentPageIndex = selected;
				Bind(dt);
			}
		}

		public string dspFile_saveKey(Object fBoardKey)
		{
			string inputtext = "";
			int key = (int) fBoardKey;

			lnkModify.NavigateUrl="modify.aspx?sql=" + m_sql + "&num=" + fBoardKey.ToString();
			lnkReply.NavigateUrl="reply.aspx?sql=" + m_sql + "&num=" + fBoardKey.ToString();
			lnkBack.NavigateUrl = "list.aspx?sql=" + m_sql;

			cFileData db = new cFileData();
			DataTable dt = db.getFileInfo(key);

			foreach(DataRow dr in dt.Rows)
			{
				inputtext += "<a href='down.aspx?p=" + dr["fFilePath"].ToString() + "&name=" + dr["fFileName"].ToString();
				inputtext += "' title='" + dr["fFileSize"].ToString() + "byte'>";
				inputtext += dr["fFileName"].ToString() + "</a><br>";
			}
			return (inputtext);
		}

		public string CountThis(Object key,Object visited)
		{
			cFileData db = new cFileData();

			string fBoardKey = key.ToString();
			string sql = "update tblBoard set fVisited=fVisited+1 where fBoardKey=" + fBoardKey;
			db.executeQuery(sql);

			return ((int.Parse(visited.ToString())+1).ToString());
		}

	public void Page_Move(Object sender,DataGridPageChangedEventArgs e)
		{
			m_DbGrid.CurrentPageIndex = e.NewPageIndex;
			m_sql = lblSql.Value;
			cFileData db = new cFileData();
			DataTable dt = db.getBoardInfo(m_sql);
			Bind(dt);
		}

		public void Bind(DataTable dt)
		{
			DataView dv = new DataView(dt);
			m_DbGrid.DataSource = dv;
			m_DbGrid.DataBind();
		}

		public string cv2Html(Object content)
		{
			string rtn = content.ToString();
			cFileData db = new cFileData();
			rtn = db.cv2Html(rtn);
			return rtn;
		}
	}

	public class cModify : Page
	{
		protected TextBox txtSubject;
		protected TextBox txtWriter;
		protected TextBox txtEmail;
		protected TextBox txtPassword;
		protected TextBox txtComment;
		protected HtmlInputFile file1;
		protected HtmlInputFile file2;

		protected HtmlInputHidden lblKey;
		protected Label lblErrorMsg;

		protected Button btnSave;
		protected Button btnCancel;

		protected void Page_Init(object sender,EventArgs e)
		{
			InitializeComponent();
		}

		private void InitializeComponent()
		{
			btnSave.Click += new System.EventHandler(this.Save_Click);
			btnCancel.Click += new System.EventHandler(this.List_Click);
		}

		public void Save_Click(Object sender,EventArgs e)
		{
			string fBoardKey = lblKey.Value;
			Boolean isPass = isRightPass(txtPassword.Text,fBoardKey);

			if(isPass)
			{
				cFileData db = new cFileData();

				db.updateBoard(fBoardKey,txtSubject.Text,txtWriter.Text,txtEmail.Text,txtComment.Text);
				db.deleteFile(int.Parse(fBoardKey));

				if(file1.PostedFile!=null && file1.PostedFile.FileName != "" )
				{
					db.uploadFile(int.Parse(fBoardKey),file1.PostedFile);
				}

				if(file2.PostedFile!=null && file2.PostedFile.FileName != "" )
				{
					db.uploadFile(int.Parse(fBoardKey),file2.PostedFile);
				}
				lblErrorMsg.Visible = false;

				Response.Redirect("list.aspx");
			}

			else
			{
				lblErrorMsg.Text = "н尡 ߸Ǿ..";
				lblErrorMsg.Visible = true;
			}
		}
		
		public void List_Click(Object sender,EventArgs e)
		{
			Response.Redirect("list.aspx");
		}

		public void Page_Load(Object sender,EventArgs e)
		{
			if(!IsPostBack)
			{
				int fBoardKey = int.Parse(Request["num"].ToString());
				displayContent(fBoardKey);
			}
		}

		public bool isRightPass(string pass,string fkey)
		{
			bool rtn=false;
			cFileData db = new cFileData();
			string sql = "select fBoardKey from tblBoard where fBoardKey = " + fkey + " and fPassword = '" + pass + "'";
			DataTable dt = db.getBoardInfo(sql);

			if(dt.Rows.Count > 0)
			{
				rtn = true;
			}
			return rtn;
		}

		public void displayContent(int key)
		{
			string sql = "select * from tblBoard where fBoardKey=" + key;
			cFileData db = new cFileData();
			DataTable dt = db.getBoardInfo(sql);

			foreach(DataRow dr in dt.Rows)
			{
				txtSubject.Text = dr["fSubject"].ToString();
				txtWriter.Text = dr["fWriter"].ToString();
				txtEmail.Text = dr["fEmail"].ToString();
				txtComment.Text = dr["fContent"].ToString();

			}

			lblKey.Value = key.ToString();
		}
	}

	public class cReply : Page
	{
		protected TextBox txtSubject;
		protected TextBox txtWriter;
		protected TextBox txtEmail;
		protected TextBox txtPassword;
		protected TextBox txtComment;
		protected HtmlInputHidden lblGroup;
		protected HtmlInputHidden lblStep;
		protected HtmlInputFile file1;
		protected HtmlInputFile file2;

		protected Button btnSave;
		protected Button btnCancel;

		protected void Page_Init(object sender,EventArgs e)
		{
			InitializeComponent();
		}

		private void InitializeComponent()
		{
			btnSave.Click += new System.EventHandler(this.Save_Click);
			btnCancel.Click += new System.EventHandler(this.List_Click);
		}

		public void Save_Click(Object sender,EventArgs e)
		{
			cFileData db = new cFileData();
			int fBoardKey = db.saveBoard(txtSubject.Text,txtEmail.Text,txtWriter.Text,txtPassword.Text,txtComment.Text,int.Parse(lblGroup.Value),int.Parse(lblStep.Value)+1);

			Response.Write(fBoardKey.ToString());

			if(fBoardKey >0)
			{
				if(file1.PostedFile!=null && file1.PostedFile.FileName != "" )
				{
					db.uploadFile(fBoardKey,file1.PostedFile);

				}
				if(file2.PostedFile!=null && file2.PostedFile.FileName != "" )
				{
					db.uploadFile(fBoardKey,file2.PostedFile);
				}

				Response.Redirect("list.aspx");
			}
		}

		public void List_Click(Object sender,EventArgs e)
		{
			Response.Redirect("list.aspx");
		}

		public void Page_Load(Object sender,EventArgs e)
		{
			if(!IsPostBack)
			{
				int fBoardKey = int.Parse(Request["num"].ToString());
				cFileData db = new cFileData();
				string sql = "select fGroup,fAnsStep from tblBoard where fBoardKey=" + fBoardKey;
				DataTable dt = db.getBoardInfo(sql);
				lblGroup.Value = dt.Rows[0]["fGroup"].ToString();
				lblStep.Value = dt.Rows[0]["fAnsStep"].ToString();
			}
		}
	}
}
